﻿


'
'
'/**
'--------------------------------------------------
' Versión .....: 25/01/2011   
'               [dd/mm/aaaa] 
' Original en .: Util
'--------------------------------------------------
'
'
' -------------------------------------------------
' Clase ....: OcrMediaPlayer
' Lenguaje .: (.NET Framework 4) - Visual Basic .NET (Versión 9.0) - 2010
' Autor ....:  - Aguila - Joaquin
' Emilio ...: mailto:joaquin@medina.name
'
'ATENCION
'    Esta clase hay que COPIARLA en el ensamblado en la que se usa
'
' DESCRIPCION.:
'    Clase que utiliza [OCR Media Player] para tocar un sonido wav
'    la dirección del sonido tiene que estar en una cadena pero con formato Url, es decir
'    funciona con direcciones del disco y con direcciones de internet
'
' OBSERVACIONES.:
'     Si es un video solo reproduce el sonido
'
'
' BIBLIOGRAFIA.:
'    sonidos en 
'    http://www.universal-soundbank.com/ambiances.htm
'
'    Windows Media Player 11 SDK Player Control Guide  
'    http://msdn.microsoft.com/es-es/library/aa392363(v=VS.85).aspx
'  
'    Windows Media Player 11 SDK Using the Windows Media Player Control with Visual Basic  
'    http://msdn.microsoft.com/es-es/library/aa393312(v=VS.85).aspx
'
'    Windows Media Player 11 SDK Creating the Windows Media Player Control Programmatically  
'    http://msdn.microsoft.com/es-es/library/aa386639(v=VS.85).aspx
'
'
' MODIFICACIONES [dd/mm/aaaa] 
'-  01/01/2011 - Creación de la clase
' - 02/01/2011 - FxCop
' - 05/01/2011 - Modifico los eventos 
' - 08/01/2011 - Añado la funcion [Shared Play]
' - 18/01/2011 - Por indicacion de FxCop creo la clase [OcrMediaPlayerResultadoPlay]
' - 19/01/2011 - modifico new
' ------------------------------------------------
'
'
'  MODO DE USO
'
''-------------------------------------
'' Ejemplo del uso de esta clase
''-------------------------------------
'
'    '--------------------------------------------
'    ' Tocar un Sonido Modelo UNO
'    '-------------------------------------------
'    ' el mensaje de error que existe
'    Dim outputMensajeError As String = String.Empty
'    ' el sonido suena toma valor true
'    ' el sonido no suena ' Toma valor false
'    Dim haTocadoElSonido As Boolean = True
'
'    haTocadoElSonido = Util.Multimedia.OcrMediaPlayer.Play("c:/NombreficheroSonodo.mp3", 1, outputMensajeError)
'    If haTocadoElSonido = False Then
'        ' Ha ahbido algun problema y no suena
'        ' Opciones posibles
'        ' Lanzar un mensaje de error advirtiendolo
'        Windows.Forms.MessageBox.Show(outputMensajeError, "PROBLEMAS EN LA REPRODUCCIN DE SONIDO")
'        ' escibir el problema en el log
'        My.Application.Log.WriteEntry(outputMensajeError, Diagnostics.TraceEventType.Information)
'    End If
'
'
'    '--------------------------------------------
'    ' Tocar un Sonido Modelo DOS
'    '-------------------------------------------
'    ' el objeto que contendrá el resultado de la operacion Play
'    Dim objResultadoPlay As Util.Multimedia.OcrMediaPlayerResultadoPlay = Nothing
'    
'    objResultadoPlay = Util.Multimedia.OcrMediaPlayer.Play("c:/NombreficheroSonodo.mp3", 1)
'    If objResultadoPlay.HaTocadoElSonido = False Then
'        ' Ha ahbido algun problema y no suena
'        ' Opciones posibles
'        ' Lanzar un mensaje de error advirtiendolo
'        Windows.Forms.MessageBox.Show(objResultadoPlay.MensajeDeError, "PROBLEMAS EN LA REPRODUCCIN DE SONIDO")
'        ' escibir el problema en el log
'        My.Application.Log.WriteEntry(objResultadoPlay.MensajeDeError, Diagnostics.TraceEventType.Information)
'    End If
'
'
'    '--------------------------------------------
'    ' Tocar un Sonido Modelo TRES
'    '-------------------------------------------
'    Private ObjMediaPlayer As New Util.Multimedia.OcrMediaPlayer("c:/NombreficheroSonodo.mp3", 1)
'    Public Sub Tocar()
'        ObjMediaPlayer.Play()
'    End Sub
'    Public Sub Parar()
'        ObjMediaPlayer.Stop()
'    End Sub
'
'*/
'

' -------------------------------------------------
Option Explicit On
Option Strict On
Option Infer Off
Option Compare Binary



'----------------------------------------
' Importacion de Windows Media Player
'  1. Haga clic en el cuadro de herramientas y seleccione Elegir elementos.
'     Esto abre el cuadro de diálogo Personalizar cuadro de herramientas.
'  2. En la ficha Componentes COM, seleccione Windows Media Player.
'     Si Reproductor de Windows Media no aparece en la lista,
'     haga clic en Examinar y, a continuación, abra WMP.dll, que debe estar
'     en la carpeta Windows \ System32.
'  3. Haga clic en Aceptar. El control de Windows Media Player se colocará
'     Sobre la actual ficha Herramientas.
'----------------------------------------
' Forma alternativa
' 1 agreagar archivo existente
'   Buscar en Windows\System32 el fichero  Wmp.dll
' 2 Agregar referencia, pestaña examinar y buscar en my proyecto el fichero que acabo de copiar  Wmp.dll
' 3 en propiedades del fichero  Wmp.dll 
'   [Accion de compilacion] Contenido
'   [Copiar en el directorio de resultados] No Copiar
'----------------------------------------
Imports WMPLib
'----------------------------------------
' ¡¡¡ ATENCION !!! Si aparece un error en la linea anterior
' comprueba que en el proyecto estre la referecia del contol OCR Windows Media Player
'

Namespace Util.Multimedia

    '=============================================================
    '=============================================================

    ''' <summary>
    '''  Clase que utiliza [OCR Media Player] para tocar un sonido wav
    '''  El sonido tiene que estar en un fichero en el disco o en una URI accasible (en internet)
    ''' </summary>
    ''' <remarks>
    ''' <code>
    '''  '-------------------------------------
    '''  ' Ejemplo del uso de esta clase
    '''  '-------------------------------------
    ''' 
    '''  '--------------------------------------------
    '''  ' Tocar un Sonido Modelo UNO
    '''  '-------------------------------------------
    '''  ' el mensaje de error que existe
    '''  Dim outputMensajeError As String = String.Empty
    '''  ' el sonido suena toma valor true
    '''  ' el sonido no suena  Toma valor false
    '''  Dim haTocadoElSonido As Boolean = True
    ''' 
    ''' haTocadoElSonido = Util.Multimedia.OcrMediaPlayer.Play("c:/NombreficheroSonodo.mp3", 1, outputMensajeError)
    ''' If haTocadoElSonido = False Then
    '''    ' Ha ahbido algun problema y no suena
    '''    ' Opciones posibles
    '''    ' Lanzar un mensaje de error advirtiendolo
    '''    Windows.Forms.MessageBox.Show(outputMensajeError, "PROBLEMAS EN LA REPRODUCCIN DE SONIDO")
    '''    ' escibir el problema en el log
    '''    My.Application.Log.WriteEntry(outputMensajeError, Diagnostics.TraceEventType.Information)
    ''' End If
    ''' 
    ''' 
    ''' 
    '''  '--------------------------------------------
    '''  ' Tocar un Sonido Modelo DOS
    '''  '-------------------------------------------
    '''  ' el objeto que contendrá el resultado de la operacion Play
    '''  Dim objResultadoPlay As Util.Multimedia.OcrMediaPlayerResultadoPlay = Nothing
    ''' 
    '''  objResultadoPlay = Util.Multimedia.OcrMediaPlayer.Play("c:/NombreficheroSonodo.mp3", 1)
    '''  If objResultadoPlay.HaTocadoElSonido = False Then
    '''    ' Ha ahbido algun problema y no suena
    '''    ' Opciones posibles
    '''    ' Lanzar un mensaje de error advirtiendolo
    '''    Windows.Forms.MessageBox.Show(objResultadoPlay.MensajeDeError, "PROBLEMAS EN LA REPRODUCCIN DE SONIDO")
    '''    ' escibir el problema en el log
    '''    My.Application.Log.WriteEntry(objResultadoPlay.MensajeDeError, Diagnostics.TraceEventType.Information)
    '''  End If
    ''' 
    '''    '--------------------------------------------
    '''    ' Tocar un Sonido Modelo TRES
    '''    '-------------------------------------------
    '''    Private ObjMediaPlayer As New Util.Multimedia.OcrMediaPlayer("c:/NombreficheroSonodo.mp3", 1)
    '''    Public Sub Tocar()
    '''        ObjMediaPlayer.Play()
    '''    End Sub
    '''    Public Sub Parar()
    '''        ObjMediaPlayer.Stop()
    '''    End Sub
    ''' </code>
    ''' </remarks>
    Public Class OcrMediaPlayer
        Implements IDisposable

        ''' <summary>
        '''  El objeto [Windows Media Player] contenido por la clase
        ''' </summary>
        ''' <remarks> 
        '''    <code> http://msdn.microsoft.com/es-es/library/dd562692(v=vs.85).aspx </code>
        ''' </remarks>
        Private WithEvents Player As WMPLib.WindowsMediaPlayer ' = Nothing

        ''' <summary>
        '''    Numero maximo de repeticiones del archivo de musica
        '''    Valor por defecto (toca la musica) 10 veces
        ''' </summary>
        ''' <remarks></remarks>
        Private Const MAXIMO_REPETICIONES As Integer = 10


#Region "Eventos"

        '-----------------------------------------------------------------------
        ' Apunte táctico - Eventos Genéricos
        '-----------------------------------------------------------------------
        ' Sustituir la firma del evento
        ' Public Event ZHoraChanged(ByVal sender As Object, ByVal e As EventArgs)
        ' http://msdn.microsoft.com/es-es/db0etb8x.aspx
        ' http://msdn.microsoft.com/es-es/ms182178.aspx
        '-----------------------------------------------------------------------

        ''' <summary>
        '''  No existen problemas
        '''  La reproduccion de sonido ha llegado a su fin
        '''  o "alguien" la ha parado
        ''' </summary>
        Public Event Stopped As EventHandler(Of OcrMediaPlayerEventArgs)
        'Public Event Stopped(ByVal sender As Object, ByVal e As OcrMediaPlayerEventArgs)


        ''' <summary>
        '''  No existen problemas
        '''  La reproduccion de sonido Comienza
        ''' </summary>
        Public Event Playing As EventHandler(Of OcrMediaPlayerEventArgs)
   
        ''' <summary>
        '''  Hay algun problema al reproducir el archivo de sonido
        ''' </summary>
        ''' <param name="sender">El objeto donde se genera el error, a sea aqui, en este objeto</param>
        ''' <param name="e">Un objeto <see cref="OcrMediaPlayerEventArgs">OcrMediaPlayerEventArgs</see> que contiene el mensaje de error</param>
        Public Event ErrorAlReproducirSonido As EventHandler(Of OcrMediaPlayerEventArgs)
 

#Region "Eventos del control []"


        '-----------------------------------------------------------------------------------
        ' Eventos
        ' No puedo reproducir el archivo de sonido.
        Private Sub Player_MediaError(ByVal pMediaObject As Object) Handles Player.MediaError

            Try
                Using SW As New System.IO.StringWriter(System.Globalization.CultureInfo.CurrentCulture)
                    SW.WriteLine("No puedo reproducir el archivo de sonido.")
                    SW.WriteLine(Player.URL)

                    If Player.Error.errorCount > 0 Then
                        For indice As Integer = 0 To Player.Error.errorCount - 1
                            SW.WriteLine(Player.Error.Item(indice).errorDescription)
                        Next
                    End If

                    If Me.Uri.IsFile = True Then
                        If System.IO.File.Exists(Player.URL) = False Then
                            SW.WriteLine("Posible error [El fichero No se encuentra en el disco]")
                        End If
                    Else
                        If My.Computer.Network.IsAvailable = False Then
                            SW.WriteLine("Posible error [No hay conexión con Internet]")
                        Else
                            SW.WriteLine("Posible error [Existe una conexión activa con Internet")
                            SW.WriteLine("Pero no es posible acceder al recurso]")
                        End If
                    End If

                    SW.Flush()
                    RaiseEvent ErrorAlReproducirSonido(Me, New OcrMediaPlayerEventArgs(SW.ToString))
                End Using

            Catch ex As InvalidCastException
                ' In case pMediaObject is not an IWMPMedia item.

                Dim mensajeError As String = "Player error." & Environment.NewLine & _
                    "Problemas con el archivo de sonido." & Environment.NewLine & _
                     Player.URL & Environment.NewLine & _
                    "El objeto [" & pMediaObject.GetType.Name & "] no es un objeto del tipo [IWMPMedia]"
                Throw New InvalidCastException(mensajeError, ex)

            End Try

        End Sub

        '  No existen problemas
        '  La reproduccion de sonido ha llegado a su fin
        '  o "alguien" la ha parado
        Private Sub Player_PlayStateChange(ByVal NewState As Integer) Handles Player.PlayStateChange

            If NewState = WMPLib.WMPPlayState.wmppsStopped Then
                '  No existen problemas
                '  La reproduccion de sonido ha llegado a su fin
                '  o "alguien" la ha parado
                RaiseEvent Stopped(Me, New OcrMediaPlayerEventArgs("wmppsStopped [" & Player.URL & "]"))
            End If
            If NewState = WMPLib.WMPPlayState.wmppsPlaying Then
                '  No existen problemas
                '  La reproduccion de sonido Comienza sin problemas
                RaiseEvent Playing(Me, New OcrMediaPlayerEventArgs("wmppsPlaying [" & Player.URL & "]"))
            End If

            '  RaiseEvent Playing(Me, New OcrMediaPlayerEventArgs("-->  [" & CType(NewState, WMPLib.WMPPlayState).ToString & "]"))
        End Sub

#End Region

#End Region

#Region "Constructores"

        ''' <summary>
        ''' Constructor basico
        ''' </summary>
        ''' <remarks>
        ''' Instancia el control ocr
        ''' Se establece a Una (1) el numero de repeticiones
        ''' </remarks>
        Private Sub New()
            ' no hacer nada
            Player = New WMPLib.WindowsMediaPlayer
            Player.settings.playCount = 1

            '--------------------------------------------------------
            ' Errores que no se resolver
            'Advertencia	1	
            ' El importador de la biblioteca de tipos detectó una función getter 
            ' de(propiedad) 'sessionPlaylistCount' en el tipo 'WMPLib.IWMPNowPlayingHelperDispatch'  
            ' sin un tipo de valor devuelto válido.   El importador intentará importar  
            ' esta propiedad como un método.	

            'Advertencia	2	 
            ' El importador de la biblioteca de tipos detectó una función getter de  
            ' propiedad 'sessionPlaylistCount' en el tipo 'WMPLib.IWMPNowPlayingHelperDispatch'  
            ' sin un tipo de valor devuelto válido.    
            ' El importador intentará importar esta propiedad como un método.	

        End Sub


        '-------------------------------------------------------------
        '  Por sugerencia del FxCop
        '  CA1054: Los parámetros de URI no deben ser cadenas
        '  http://msdn.microsoft.com/library/ms182174(VS.100).aspx
        '-------------------------------------------------------------
        ''' <summary>
        '''     CONSTRUCTOR PRINCIPAL
        ''' </summary>
        ''' <param name="uri">La rutaArchivo que se 'toca'</param>
        ''' <remarks>
        '''  Se instancia le control OCR
        '''  se almacena la direccion en el control OCR
        '''</remarks>
        Public Sub New(ByVal uri As System.Uri)
            Me.new()

            ' Problemilla
            ' --> [uri.ToString] añade delante de la ruta file:///c:etc
            '     y la funcion [ Player.URL] no lo reconoce y 
            '     no toca el fichero
            ' --> La cadena devuelta por [AbsolutePath] contiene caracteres de escape (%20) 
            '     en aquellos directorios que tienen espacios y tenemos el mismo problema
            ' --> Solucion : Al usar [LocalPath] se resuelve el problema
            ' --> Si es un recurso de internet [AbsolutePath] No siempre funciona
            '     es mejor usar [AbsoluteUri]
            If uri.IsFile = True Then
                Player.URL = uri.LocalPath
            Else
                Player.URL = uri.AbsoluteUri
            End If

        End Sub


        ''' <summary>
        '''  Constructor
        ''' </summary>
        ''' <param name="uri">La rutaArchivo que se 'toca'</param>
        ''' <param name="numeroVeces">el numero de veces que se repite la musica</param>
        ''' <remarks>
        '''  Se instancia le control OCR
        '''  se almacena la direccion en el control OCR
        '''  se almacena el numero de repticiones en el control OCR
        '''</remarks>
        Public Sub New(ByVal uri As System.Uri, ByVal numeroVeces As Integer)
            Me.new(uri)
            Player.settings.playCount = numeroVeces
        End Sub



        ''' <summary>
        '''  Constructor
        ''' </summary>
        ''' <param name="nombreFichero">La rutaArchivo que se 'toca'</param>
        ''' <remarks>
        '''  Se instancia le control OCR
        '''  se almacena la direccion en el control OCR
        '''  <code> 
        '''    Regla FxCop --> Llamar al constructorr URI
        '''    http://msdn.microsoft.com/library/ms182170(VS.100).aspx 
        ''' </code>
        '''</remarks>
        Public Sub New(ByVal nombreFichero As String)
            Me.new(New Uri(nombreFichero))
        End Sub


        ''' <summary>
        '''  Constructor
        ''' </summary>
        ''' <param name="nombreFichero">La rutaArchivo que se 'toca'</param>
        ''' <param name="numeroVeces">el numero de veces que se repite la musica</param>
        ''' <remarks>
        '''  Se instancia le control OCR
        '''  se almacena la direccion en el control OCR
        '''  se almacena el numero de repticiones en el control OCR
        ''' <code> 
        '''    Regla FxCop --> Llamar al constructorr URI
        '''    http://msdn.microsoft.com/library/ms182170(VS.100).aspx 
        ''' </code>
        '''</remarks>
        Public Sub New(ByVal nombreFichero As String, ByVal numeroVeces As Integer)
            Me.new(New Uri(nombreFichero), numeroVeces)
        End Sub


#End Region

#Region "Propedades y funciones"

        ''' <summary>
        ''' Numero de repeticiones. Numero de veces que se 'toca' la musica
        ''' </summary>
        Public Property PlayCount() As Integer
            Get
                Return Player.settings.playCount
            End Get
            Set(ByVal value As Integer)
                Player.settings.playCount = value
            End Set
        End Property


        ''' <summary>
        ''' Una cadena con La rutaArchivo del sonido
        ''' (Se carga en el constructor)
        ''' </summary>
        Public Property RutaArchivoSonido() As String
            Get
                '-------------------------------------------------------
                ' problemilla encontrado
                ' uri.ToString--> añade delante de la ruta file:///c:etc
                ' y la funcion [System.IO.File.Exists] no lo reconoce y 
                ' devuelve false aunque exista el fichero en el disco
                ' Solucion: Al usar [AbsolutePath] se resuelve el problema
                '-------------------------------------------------------
                Dim auxUrl As New Uri(Player.URL)
                Return auxUrl.AbsolutePath
            End Get
            Friend Set(ByVal value As String)
                If String.IsNullOrEmpty(value) = True Then
                    RaiseEvent ErrorAlReproducirSonido( _
                        Me, New OcrMediaPlayerEventArgs("El archivo de sonido no puede tener un valor Vacio o Nulo"))
                    Exit Property
                End If
                Dim auxUrl As New Uri(value)
                Player.URL = auxUrl.AbsolutePath
            End Set
        End Property

        ''' <summary>
        ''' La Uri del sonido
        ''' (Se carga en el constructor)
        ''' </summary>
        Public ReadOnly Property [Uri]() As Uri
            Get
                Dim auxUrl As New Uri(Player.URL)
                Return auxUrl
            End Get
        End Property


        ''' <summary>
        '''  Tocar el sonido
        ''' </summary>
        Public Overloads Sub Play()
            ' si hay algo tocando pararlo primero
            ' no parece que funicone
            If Player.playState = WMPPlayState.wmppsPlaying Then
                Player.controls.stop()
            End If
            Player.controls.play()
        End Sub


        '''  <summary>
        '''    Parar el sonido
        ''' </summary>
        Public Sub [Stop]()
            ' My.Computer.Audio.Stop() no funciona :-(
            Player.controls.stop()
        End Sub

#End Region

#Region "Shared - Propedades y funciones"



        ''--------------------------------------------
        '' Tocar un Sonido
        ''-------------------------------------------
        '' el mensaje de error que existe
        'Dim outputMensajeError As String = String.Empty
        '' el sonido suena toma valor true
        '' el sonido no suena ' Toma valor false
        'Dim HaTocado As Boolean = True

        'HaTocado = Util.Sonido.OcrMediaPlayer.Play(Me.UcTextBoxNombreFichero.Text, 1, outputMensajeError)
        'If HaTocado = False Then
        '    Me.ErrorProvider1.SetError(UcTextBoxNombreFichero, outputMensajeError)
        'End If



        ''' <summary>
        '''  Reproduce un fichero de sonido usando [Windows Media Player]
        ''' </summary>
        ''' <param name="rutaArchivoSonido">
        '''   <para>Tipo: <see cref="System.String">System.String</see></para>
        '''   <para>La cadena que contiene la Uri. (la ruta) del fichero de sonido</para>
        '''   <para>Por ejemplo: Un nombre completo de fichero</para>
        '''   <para>Por ejemplo: Un recurso web</para>
        ''' </param>
        ''' <param name="numeroRepeticiones">El número de veces que se repetira el sonido (valor minimo 1, maximo 10)</param>
        ''' <param name="outputMensajeError">
        '''   <para>Tipo: <see cref="System.String">System.String</see></para>
        '''   <para>Mensaje que describe el error que ha ocurrido. </para>
        '''   <para>Se utiliza un parámetro ByRef para devolver un valor</para>
        '''   <para>Si todo sale bien este parámetro toma el valor de cadena vacía. [String.Empty] </para> 
        '''   <para>Si ocurre algún error, este parámetro se carga con un texto que describe (más o menos) el error que ha ocurrido) </para>
        ''' </param>
        ''' <returns>
        '''   <para> Tipo: <see cref="System.Boolean">System.Boolean</see></para>
        '''   <para> Devuelve un Valor lógico Que responde a la pregunta ¿Ha funcionado todo bien?: </para>
        '''   <para> True. Sin problemas, todo funciono bien</para>
        '''   <para> False ¡Cuidado! Ha habido algún problema</para>
        ''' </returns>
        Public Overloads Shared Function Play( _
                         ByVal rutaArchivoSonido As String, _
                         ByVal numeroRepeticiones As Integer,
                         <Runtime.InteropServices.Out()> ByRef outputMensajeError As String) _
                     As Boolean
            Dim auxUri As System.Uri = Nothing
            Try
                auxUri = New Uri(rutaArchivoSonido)
                Return Play(auxUri, numeroRepeticiones, outputMensajeError)
            Catch ex As Exception
                Throw
            Finally
                If Not (auxUri Is Nothing) Then
                    auxUri = Nothing
                End If
            End Try

        End Function

        '---------------------------------------------------
        '---------------------------------------------------
        ' FUNCION CREADA POR ---> Sugerencia FxCop
        '---------------------------------------------------
        '---------------------------------------------------
        ''' <summary>
        '''  Reproduce un fichero de sonido usando [Windows Media Player]
        ''' </summary>
        ''' <param name="uri">
        '''   <para>Tipo: <see cref="System.Uri">System.Uri</see></para>
        '''   <para>un objeto Uri que contiene la Uri. (la ruta) del fichero de sonido</para>
        '''   <para>Por ejemplo: Un nombre completo de fichero</para>
        '''   <para>Por ejemplo: Un recurso web</para>
        ''' </param>
        ''' <param name="numeroRepeticiones">El número de veces que se repetira el sonido (valor minimo 1, maximo 10)</param>
        ''' <param name="outputMensajeError">
        '''   <para>Tipo: <see cref="System.String">System.String</see></para>
        '''   <para>Mensaje que describe el error que ha ocurrido. </para>
        '''   <para>Se utiliza un parámetro ByRef para devolver un valor</para>
        '''   <para>Si todo sale bien este parámetro toma el valor de cadena vacía. [String.Empty] </para> 
        '''   <para>Si ocurre algún error, este parámetro se carga con un texto que describe (más o menos) el error que ha ocurrido) </para>
        ''' </param>
        ''' <returns>
        '''   <para> Tipo: <see cref="System.Boolean">System.Boolean</see></para>
        '''   <para> Devuelve un Valor lógico Que responde a la pregunta ¿Ha funcionado todo bien?: </para>
        '''   <para> True. Sin problemas, todo funciono bien</para>
        '''   <para> False ¡Cuidado! Ha habido algún problema</para>
        ''' </returns>
        Public Overloads Shared Function Play( _
                          ByVal uri As System.Uri, _
                          ByVal numeroRepeticiones As Integer,
                          <Runtime.InteropServices.Out()> ByRef outputMensajeError As String) _
                      As Boolean

            '------------------------------------
            ' el mensaje de error que existe
            ' outputMensajeError = String.Empty
            '' el sonido suena toma valor true
            '' el sonido no suena ' Toma valor false
            'Dim HaTocado As Boolean = True


            Dim objResultado As OcrMediaPlayerResultadoPlay = Nothing
            Try
                objResultado = Play(uri, numeroRepeticiones)
                outputMensajeError = objResultado.MensajeDeError
                Return objResultado.HaTocadoElSonido
            Catch ex As Exception
                Throw
            Finally
                If Not (objResultado Is Nothing) Then
                    objResultado.Dispose()
                    objResultado = Nothing
                End If
            End Try
        End Function



        ''' <summary>
        '''  Reproduce un fichero de sonido usando [Windows Media Player]
        ''' </summary>
        ''' <param name="rutaArchivoSonido">
        '''   <para>Tipo: <see cref="System.String">System.String</see></para>
        '''   <para>La cadena que contiene la Uri. (la ruta) del fichero de sonido</para>
        '''   <para>Por ejemplo: Un nombre completo de fichero</para>
        '''   <para>Por ejemplo: Un recurso web</para>
        ''' </param>
        ''' <param name="numeroRepeticiones">El número de veces que se repetira el sonido (valor minimo 1, maximo 10)</param>
        ''' <returns>
        '''   <para> Tipo: <see cref="OcrMediaPlayerResultadoPlay">OcrMediaPlayerResultadoPlay</see></para>
        '''   <para> Objeto que contiene el resultado de la operacion en dos propiedades</para>
        '''   <para> <see cref="OcrMediaPlayerResultadoPlay.MensajeDeError">MensajeDeError</see></para>
        '''   <para> Contiene un mensaje que describe el error que ha ocurrido. </para>
        '''   <para> Si todo sale bien toma el valor de cadena vacía. [String.Empty] </para> 
        '''   <para> Si ocurre algún error, se carga con un texto que describe (más o menos) el error que ha ocurrido) </para>
        '''   <para> <see cref="OcrMediaPlayerResultadoPlay.HaTocadoElSonido">HaTocadoElSonido</see></para>
        '''   <para> Contiene un Valor lógico Que responde a la pregunta ¿el sonido Ha sonado?: </para>
        '''   <para> True. Sin problemas, todo funciono bien</para>
        '''   <para> False ¡Cuidado! Ha habido algún problema</para>
        ''' </returns>
        Public Overloads Shared Function Play( _
                           ByVal rutaArchivoSonido As String, _
                           ByVal numeroRepeticiones As Integer) _
                            As OcrMediaPlayerResultadoPlay

            Dim auxUri As System.Uri = Nothing
            Try
                auxUri = New Uri(rutaArchivoSonido)
                Return Play(auxUri, numeroRepeticiones)
            Catch ex As Exception
                Throw
            Finally
                If Not (auxUri Is Nothing) Then
                    auxUri = Nothing
                End If
            End Try

        End Function

    
        ''' <summary>
        '''  Reproduce un fichero de sonido usando [Windows Media Player]
        ''' </summary>
        ''' <param name="uri">
        '''   <para>Tipo: <see cref="System.Uri">System.Uri</see></para>
        '''   <para>un objeto Uri que contiene la Uri. (la ruta) del fichero de sonido</para>
        '''   <para>Por ejemplo: Un nombre completo de fichero</para>
        '''   <para>Por ejemplo: Un recurso web</para>
        ''' </param>
        ''' <param name="numeroRepeticiones">El número de veces que se repetira el sonido (valor minimo 1, maximo 10)</param>
        ''' <returns>
        '''   <para> Tipo: <see cref="OcrMediaPlayerResultadoPlay">OcrMediaPlayerResultadoPlay</see></para>
        '''   <para> Objeto que contiene el resultado de la operacion en dos propiedades</para>
        '''   <para> <see cref="OcrMediaPlayerResultadoPlay.MensajeDeError">MensajeDeError</see></para>
        '''   <para> Contiene un mensaje que describe el error que ha ocurrido. </para>
        '''   <para> Si todo sale bien toma el valor de cadena vacía. [String.Empty] </para> 
        '''   <para> Si ocurre algún error, se carga con un texto que describe (más o menos) el error que ha ocurrido) </para>
        '''   <para> <see cref="OcrMediaPlayerResultadoPlay.HaTocadoElSonido">HaTocadoElSonido</see></para>
        '''   <para> Contiene un Valor lógico Que responde a la pregunta ¿el sonido Ha sonado?: </para>
        '''   <para> True. Sin problemas, todo funciono bien</para>
        '''   <para> False ¡Cuidado! Ha habido algún problema</para>
        ''' </returns>
        Public Overloads Shared Function Play( _
                           ByVal uri As System.Uri, _
                           ByVal numeroRepeticiones As Integer) _
                           As OcrMediaPlayerResultadoPlay

            '------------------------------------
            ' el Objeto con el resultado de la funcion
            Dim objResultadoPlay As New OcrMediaPlayerResultadoPlay

            If uri Is Nothing Then
                objResultadoPlay.HaTocadoElSonido = False
                objResultadoPlay.MensajeDeError = "El objeto [ System.Uri] que contiene la ruta del fichero de sonido tiene un valor [Nothing] "
                Return objResultadoPlay '------------>>>>>>>>>>>
            End If

            '------------------------------------
            Dim rutaArchivoSonido As String = uri.AbsolutePath
            '------------------------------------
            If rutaArchivoSonido Is Nothing Then
                objResultadoPlay.HaTocadoElSonido = False
                objResultadoPlay.MensajeDeError = "La cadena que contiene la ruta del fichero de sonido tiene un valor [Nothing] "
                Return objResultadoPlay '------------>>>>>>>>>>>
            End If
            If rutaArchivoSonido.Length = 0 Then
                objResultadoPlay.HaTocadoElSonido = False
                objResultadoPlay.MensajeDeError = "La cadena que contiene la ruta del fichero de sonido tiene un valor [String.Empty] "
                Return objResultadoPlay '------------>>>>>>>>>>>
            End If
            If numeroRepeticiones < 1 Then numeroRepeticiones = 1
            If numeroRepeticiones > MAXIMO_REPETICIONES Then numeroRepeticiones = MAXIMO_REPETICIONES

            '---------------------------------------------------
            Try
                Using _Player As New Util.Multimedia.OcrMediaPlayer(rutaArchivoSonido, numeroRepeticiones)
                    _Player.Play()
                End Using
                ' sin problemas todo ha funcionado
            Catch ex As Exception
                '-----------------------------------------------
                'Ignoro la norma FxCop 
                '  [CriticalError, Certainty 95, for DoNotCatchGeneralExceptionTypes]
                '  CA1031: No capturar los tipos de excepción general
                '  http://msdn.microsoft.com/library/ms182137(VS.100).aspx
                '-----------------------------------------------
                ' problemas, el fichero no suena
                ' mensaje de error
                objResultadoPlay.HaTocadoElSonido = False
                objResultadoPlay.MensajeDeError = ex.Message
                Return objResultadoPlay '------------>>>>>>>>>>>
            End Try
            Return objResultadoPlay '------------>>>>>>>>>>>
        End Function



#End Region


#Region "IDisposable Support"
        Private disposedValue As Boolean ' Para detectar llamadas redundantes

        ' IDisposable
        Protected Overridable Sub Dispose(ByVal disposing As Boolean)
            If Not Me.disposedValue Then
                If disposing Then
                    ' TODO: eliminar estado administrado (objetos administrados).
                End If
                ' liberar recursos no administrados (objetos no administrados) e invalidar Finalize() below.
                If Not (Player Is Nothing) Then
                    Player = Nothing
                End If
                ' Establecer campos grandes como Null.
            End If
            Me.disposedValue = True
        End Sub

        ' invalidar Finalize() sólo si la instrucción Dispose(ByVal disposing As Boolean) anterior tiene código para liberar recursos no administrados.
        Protected Overrides Sub Finalize()
            ' No cambie este código. Ponga el código de limpieza en la instrucción Dispose(ByVal disposing As Boolean) anterior.
            Dispose(False)
            MyBase.Finalize()
        End Sub

        ' Visual Basic agregó este código para implementar correctamente el modelo descartable.
        Public Sub Dispose() Implements IDisposable.Dispose
            ' No cambie este código. Coloque el código de limpieza en Dispose (ByVal que se dispone como Boolean).
            Dispose(True)
            GC.SuppressFinalize(Me)
        End Sub
#End Region

    End Class

    '=============================================================
    '=============================================================

    ''' <summary>
    '''  Clase que contiene un evento personalizado
    ''' </summary>
    ''' <remarks></remarks>
    Public Class OcrMediaPlayerEventArgs
        Inherits System.EventArgs

        Private _texto As String
        ''' <summary>
        '''  Mensaje que contiene el evento
        ''' </summary>
        Public Property Message() As String
            Get
                Return _texto
            End Get
            Set(ByVal value As String)
                _texto = value
            End Set
        End Property

        ''' <summary>
        '''  Constructor
        ''' </summary>
        ''' <param name="pMensaje"> Mensaje que contiene el evento</param>
        Public Sub New(ByVal pMensaje As String)
            Me._texto = pMensaje
        End Sub


    End Class


    '=============================================================
    '=============================================================

    ''' <summary>
    '''  Clase que contiene el resultado de la operacion Play de la clase  <see cref="OcrMediaPlayer">OcrMediaPlayer </see>
    ''' </summary>
    ''' <remarks></remarks>
    Public Class OcrMediaPlayerResultadoPlay
        Implements IDisposable


        Public Sub New()
            ' situacion en la que no hay ningun error
            ' y todo ha funcionado correctamente
            Me.MensajeDeError = String.Empty
            Me.HaTocadoElSonido = True
        End Sub

        ''' <summary>
        '''  Constructor
        ''' </summary>
        ''' <param name="mensajeDeError"> El mensaje que describe el error que ha ocurrido</param>
        ''' <param name="haTocadoElSonido"> El sonido ha sonado o no</param>
        Public Sub New(ByVal mensajeDeError As String, ByVal haTocadoElSonido As Boolean)
            Me.New()
            Me.MensajeDeError = mensajeDeError
            Me.HaTocadoElSonido = haTocadoElSonido
        End Sub


        Private _MensajeDeError As String
        ''' <summary>
        '''  El mensaje que describe el error que ha ocurrido
        ''' </summary>
        Public Property MensajeDeError() As String
            Get
                Return _MensajeDeError
            End Get
            Set(ByVal value As String)
                _MensajeDeError = value
            End Set
        End Property


        Private _HaTocadoElSonido As Boolean
        ''' <summary>
        '''  El sonido ha sonado o no
        ''' </summary>
        ''' <returns>
        ''' Un valor logico que indica:
        ''' El sonido suena toma valor true
        ''' El sonido no suena ' Toma valor false
        '''</returns>
        Public Property HaTocadoElSonido() As Boolean
            Get
                Return _HaTocadoElSonido
            End Get
            Set(ByVal value As Boolean)
                _HaTocadoElSonido = value
            End Set
        End Property





#Region "IDisposable Support"
        Private disposedValue As Boolean ' Para detectar llamadas redundantes

        ' IDisposable
        Protected Overridable Sub Dispose(ByVal disposing As Boolean)
            If Not Me.disposedValue Then
                ' TODO: Establecer campos grandes como Null.
                _HaTocadoElSonido = Nothing
                _MensajeDeError = Nothing
            End If
            Me.disposedValue = True
        End Sub

        ' Visual Basic agregó este código para implementar correctamente el modelo descartable.
        Public Sub Dispose() Implements IDisposable.Dispose
            ' No cambie este código. Coloque el código de limpieza en Dispose (ByVal que se dispone como Boolean).
            Dispose(True)
            GC.SuppressFinalize(Me)
        End Sub
#End Region

    End Class



End Namespace